#define _OT4XB_MAP_WAPIST_FUNC_
#include "ot4xb.ch"
//----------------------------------------------------------------------------------------------------------------------
#define OT4XB_MIN_VER "001.005.012.099"
// ---------------------------------------------------------------------------
#define HKLM  (dwfix( 0x8000,0x0002))
// ---------------------------------------------------------------------------
static init proc _ipcfg_init_proc_
local e
   if ot4xb() < OT4XB_MIN_VER
      e := Error():New()
      e:severity := 2
      e:description := cPrintf(,"This module require ot4xb [%s] or higher.\r\n Current is %s", OT4XB_MIN_VER, ot4xb())
      Eval(ErrorBlock(),e)
   end     
return
//----------------------------------------------------------------------------------------------------------------------
function _aGetAdapterInfo(lDns,lAlias)
local aRet := NIL
local pBuffer  := 0
local pSize,nSize
local oAdapter := IP_ADAPTER_INFO():New()
local nError
local oInfo
local pia
local hKey,cKey,cKPrefix,pValue,pName,nShift
local oIp
local nAdapters := 0

DEFAULT lAlias := .F.
DEFAULT lDns   := .F.           

if lIsWin9x() ; lDns := .F. ; end // Not Available in Win9x

nSize     := 512
pBuffer   := _xgrab( nSize  ) // Allocate memory
nError    := @iphlpapi:GetAdaptersInfo(pBuffer,@nSize)
BEGIN SEQUENCE 
   if ( nError == 111 ) // ERROR_BUFFER_OVERFLOW
      _xfree( pBuffer ); pBuffer := _xgrab(nSize)
      nError  := @iphlpapi:GetAdaptersInfo(pBuffer,@nSize)
   end
   if( nError == 232 ) // ERROR_NO_DATA
      aRet := {} 
      BREAK
   end  
   if ( nError != 0 ) 
      BREAK
   end
   aRet := {}
   pia  := pBuffer
   while ( pia != 0 )
      oAdapter:_link_(pia,.F.)
      aAdd( aRet , TIPAdapterInfo__Init(oAdapter,lAlias,lDns) )
      pia := oAdapter:_Next
   end
END SEQUENCE
_xfree( pBuffer )
return aRet
// ---------------------------------------------------------------------------
static function TIPAdapterInfo__cAdapterTypeToName( nType )
static acTypes := {"","OTHER","ETHERNET","TOKENRING ",;
                  "FDDI","PPP","LOOPBACK","SLIP"}
static anTypes := {1,6,9,15,23,24,28}
return acTypes[(aScan(anTypes,nType)+1)]
// ---------------------------------------------------------------------------
static function TIPAdapterInfo__Init(oAdapter,lAlias,lDns)
local oo := TIPAdapterInfo():New()
oo:nComboIndex   := oAdapter:ComboIndex
oo:cAdapterName  := oAdapter:AdapterName
if lAlias
   oo:cAdapterAlias := TIPAdapterInfo__cGetAliasName_( oo:cAdapterName )
else
   oo:cAdapterAlias := ""
end
oo:cDescription         := oAdapter:Description
oo:cMacAddress          := cBin2Hex(Left( oAdapter:Address,oAdapter:AddressLength ))
oo:nIndex               := oAdapter:Index
oo:nType                := oAdapter:Type
oo:cType                := TIPAdapterInfo__cAdapterTypeToName( oo:nType )
oo:lDHCPEnabled         := oAdapter:DhcpEnabled
oo:oIpList              := TIPAdapterInfo__GetIpObjects(  oAdapter:IpAddressList:_addressof_() )
oo:aIPList              := TIPAdapterInfo__aGetIpList_( oo:oIpList )
oo:oGateway             := TIPAdapterInfo__GetIpObjects( oAdapter:GatewayList:_addressof_() )
oo:oDhcpServer          := TIPAdapterInfo__GetIpObjects( oAdapter:DhcpServer:_addressof_() )
oo:lHaveWins            := oAdapter:HaveWins
oo:oPrimaryWinsServer   := TIPAdapterInfo__GetIpObjects( oAdapter:PrimaryWinsServer:_addressof_() )
oo:oSecondaryWinsServer := TIPAdapterInfo__GetIpObjects( oAdapter:SecondaryWinsServer:_addressof_() )
oo:nLeaseObtained       := oAdapter:LeaseObtained
oo:nLeaseExpires        := oAdapter:LeaseExpires
if lDns
   TIPAdapterInfo__AddPerAdapterInfo(oo)
end
return oo
// ---------------------------------------------------------------------------
static function TIPAdapterInfo__cGetAliasName_(cName)
local cKey   := "SYSTEM\CurrentControlSet\Control\Network\" +;
                "{4D36E972-E325-11CE-BFC1-08002BE10318}\" + ;
                 cName + "\Connection"
local hKey   := 0
local nLen   := 512
local cValue := ChrR(0,nLen+1)
if ( @advapi32:RegOpenKeyExA( HKLM ,cKey,0,1,@hKey) == 0 )
   if ( @advapi32:RegQueryValueExA(hKey,"Name",0,0,@cValue,@nLen) != 0 )
      cValue := ""
   end
  @advapi32:RegCloseKey(hKey)
end
return TrimZ(cValue)
// ---------------------------------------------------------------------------
static function TIPAdapterInfo__GetIpObjects( pIpList )
local oIP     := IP_ADDR_STRING():New()
local oFirst, oo
if Empty(pIpList) ; return NIL ; end   

oFirst := oo := TIPList():New()

while pIpList != 0    
   oIp:_link_(pIpList,.F.)
   oo:cIP         := TrimZ( oIp:IpAddress )
   oo:nIP         := @ws2_32:inet_addr( oIp:_addressof_("IpAddress") )
   oo:cMask       := TrimZ( oIp:IpMask )
   oo:nMask       := @ws2_32:inet_addr( oIp:_addressof_("IpMask") )
   oo:nContext    := oIp:Context
   pIpList        :=  oIp:_Next
   if( pIpList != 0 )
      oo:oNext := TIPList():New()
   end
   oo := oo:oNext
end
return oFirst
// ---------------------------------------------------------------------------
static function TIPAdapterInfo__aGetIpList_( oIpList )
local aList := {}
local oo := oIpList
while oo != NIL
   aAdd( aList , oo:cIp )
   oo := oo:oNext
end
return aList
// ---------------------------------------------------------------------------
static function TIPAdapterInfo__AddPerAdapterInfo(oInfo)
local nIndex  := oInfo:nIndex
local nSize   := 512
local pBuffer := _xgrab( nSize )
local oPer
local nError  := @iphlpapi:GetPerAdapterInfo(nIndex,pBuffer,@nSize)

if ( nError == 111 ) // ERROR_BUFFER_OVERFLOW
   _xfree( pBuffer ); pBuffer := _xgrab(nSize)
   nError := @iphlpapi:GetPerAdapterInfo((nIndex),pBuffer,@nSize)
end
if ( nError == 0 )
   oPer := IP_PER_ADAPTER_INFO():New()
   oPer:_link_(pBuffer,.F.)
   oInfo:lAutoIpEnabled := oPer:AutoconfigEnabled
   oInfo:lAutoIpActive  := oPer:AutoconfigActive
   oInfo:oDNS := TIPAdapterInfo__GetIpObjects( oPer:DnsServerList:_addressof_() )
end
_xfree( pBuffer )
return NIL
// ---------------------------------------------------------------------------
function _aGetTcpTable( lSort)
local nSize    := 1024
local pBuffer  := _xgrab(nSize)
local nShift   := 0
local nError   := 0
local nItems,n,aRet,oo,aRow
local aStatus := {"CLOSED","LISTEN","SYN_SENT","SYN_RCVD","ESTAB","FIN_WAIT1",;
                  "FIN_WAIT2","CLOSE_WAIT","CLOSING","LAST_ACK","TIME_WAIT",;
                  "DELETE_TCB"}
                                  

DEFAULT lSort := .F.

nError := @iphlpapi:GetTcpTable(pBuffer,@nSize,lSort)
if ( nError == 111 ) // ERROR_BUFFER_OVERFLOW
   _xfree( pBuffer ); pBuffer := _xgrab(nSize)
   nError := @iphlpapi:GetTcpTable(pBuffer,@nSize,lSort)
end
if ( nError == 0 ) 
   nItems := PeekDWord( pBuffer , @nShift )
   aRet := Array(nItems)
   for n := 1 to nItems
      aRow := PeekDWord( pBuffer , @nShift , 5 ) 
      oo   := TMibTcpRow():New()
      oo:nStatus      := aRow[1]
      oo:cStatus      := iif( (oo:nStatus > 0) .and. (oo:nStatus < Len( aStatus) ),aStatus[oo:nStatus],"?")
      oo:nLocalIP     := aRow[2]
      oo:cLocalIP     := PeekStr(@ws2_32:inet_ntoa(oo:nLocalIP),,-1)
      oo:nLocalPort   := whlByteRev(aRow[3])
      oo:nRemoteIP    := aRow[4]
      oo:cRemoteIP    := PeekStr(@ws2_32:inet_ntoa(oo:nRemoteIP),,-1)
      oo:nRemotePort  := whlByteRev(aRow[5])
      aRet[n] := oo
   next
end
_xfree( pBuffer )
return aRet
// ---------------------------------------------------------------------------
function _aGetUdpTable( lSort)
local nSize    := 1024
local pBuffer  := _xgrab(nSize)
local nShift   := 0
local nError   := 0
local nItems,n,aRet,oo
                                  

DEFAULT lSort := .F.

nError := @iphlpapi:GetUdpTable(pBuffer,@nSize,lSort)
if ( nError == 111 ) // ERROR_BUFFER_OVERFLOW
   _xfree( pBuffer ); pBuffer := _xgrab(nSize)
   nError := @iphlpapi:GetUdpTable(pBuffer,@nSize,lSort)
end
if ( nError == 0 ) 
   nItems := PeekDWord( pBuffer , @nShift )
   aRet := Array(nItems)
   for n := 1 to nItems
      oo   := TMibUdpRow():New()
      oo:nLocalIP     := PeekDWord( pBuffer , @nShift ) 
      oo:cLocalIP     := PeekStr(@ws2_32:inet_ntoa(oo:nLocalIP),,-1)
      oo:nLocalPort   := whlByteRev( PeekDWord( pBuffer , @nShift ) )
      aRet[n] := oo
   next
end
_xfree( pBuffer )
return aRet
// ---------------------------------------------------------------------------
static CLASS TIPAdapterInfo
EXPORTED:
VAR nComboIndex,cAdapterName,cAdapterAlias,cDescription,cMacAddress,nIndex,;
    nType,cType,lDHCPEnabled,aIPList,oIpList,oGateway,oDhcpServer,lHaveWins,;
    oPrimaryWinsServer,oSecondaryWinsServer,nLeaseObtained,nLeaseExpires,;
    lAutoIpEnabled,lAutoIpActive,oDNS
ENDCLASS
// ---------------------------------------------------------------------------
static CLASS TIPList
EXPORTED:
VAR oNext,cIP,nIP,cMask,nMask,nContext
ENDCLASS
// ---------------------------------------------------------------------------
static CLASS TMibTcpRow
EXPORTED:
VAR nStatus,cStatus,nLocalIP,cLocalIP,nLocalPort,nRemoteIP,cRemoteIP,nRemotePort
ENDCLASS
// ---------------------------------------------------------------------------
static CLASS TMibUdpRow
EXPORTED:
VAR nLocalIP,cLocalIP,nLocalPort
ENDCLASS
// ---------------------------------------------------------------------------
